Attribute VB_Name = "modSetting"
' ListView: Inhalt in eine Datei speichern
Public Sub lvw_WriteData(lvw As ListView, _
  sDataFile As String)

On Error Resume Next

  Dim F As Integer
  Dim intCols As Integer
  Dim I As Integer
  Dim U As Integer
  Dim num As Integer
  
  If lvw = ListView2 Or lvw = listview1 Then
  num = 2
  Else
  num = 1
  End If
  
  ' Datei ffnen (ggf. berschreiben)
  F = FreeFile
  Open sDataFile For Output As #F
  
  ' Anzahl Spalten im ListView
  intCols = lvw.ColumnHeaders.Count
  
  ' ListView zeilenweise speichern
  With lvw.ListItems
    For I = num To .Count
      With lvw.ListItems(I)
        ' als erstes wird der Key-Wert gespeichert
        Print #F, .Key; vbTab;
        
        ' dann wird der Text der 1. Spalte gespeichert
        Print #F, .Text;
        
        ' Jetzt alle weiteren Spalten-Inhalte
        For U = 1 To intCols - 1
          Print #F, vbTab; .SubItems(U);
        Next U
        
        ' Zeilenvorschub
        Print #F, ""
      End With
    Next I
  End With
  
  ' Datei schliessen
  Close #F
End Sub

' ListView: Inhalt aus Datei einlesen und anzeigen
' bAppend gibt an, ob der Inhalt angefgt (True)
' oder das ListView vorher gelscht werden soll (False)
Public Sub lvw_ReadData(lvw As ListView, _
  ByVal sDataFile As String, _
  Optional ByVal bAppend As Boolean = False)

On Error Resume Next

  Dim F As Integer
  Dim sLine As String
  Dim sItem() As String
  Dim intCols As Integer
  Dim I As Integer
  Dim ItemX As ListItem
  

  
  ' Existiert die Datei berhaupt?
  If Dir(sDataFile, vbNormal) <> "" Then
  
    ' ListView lschen (falls bAppend = False)
  If Not bAppend Then lvw.ListItems.Clear
    ' Anzahl Spalten im ListView
    intCols = lvw.ColumnHeaders.Count

    ' Datei zum Lesen ffnen
    F = FreeFile
    Open sDataFile For Input As #F
    
    ' Inhalt zeilenweise auslesen
    With lvw.ListItems
      While Not EOF(F)
        Line Input #F, sLine
      
        ' Zeile in die einzelnen Spalten zerlegen
        sItem = Split(sLine, vbTab)
        
        ' Falls die Anzahl Datenspalten nicht mit der
        ' Anzahl Spalten im ListView bereinstimmen,
        ' -> Array "zurechtrcken"
        If UBound(sItem) <> intCols Then
          ReDim Preserve sItem(intCols)
        End If
        
        ' 1. Eintrag (sItem(0)) enthlt den Key-Wert
        Set ItemX = .Add(, sItem(0), sItem(1))
        
        ' Jetzt aller "SubItems"-Daten hinzufgen
        For I = 2 To intCols
          ItemX.SubItems(I - 1) = sItem(I)
        Next I
      Wend
    End With
    
    ' Datei schliessen
    Close #F
  End If
End Sub





