Attribute VB_Name = "modOnTop"
Private Declare Function SetWindowPos Lib "user32" _
  (ByVal hWnd As Long, _
  ByVal hWndInsertAfter As Long, ByVal x As Long, _
  ByVal y As Long, ByVal cx As Long, _
  ByVal cy As Long, ByVal wFlags As Long) As Long

Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1

' Fenster in den Vordergrund setzen
Public Sub FormOnTop(ByVal hWnd As Long, _
  ByVal OnTop As Boolean)

  If OnTop Then
    ' immer im Vordergrund
    SetWindowPos hWnd, HWND_TOPMOST, 0, 0, 0, 0, _
      SWP_NOMOVE Or SWP_NOSIZE
  Else
    ' normal
    SetWindowPos hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, _
      SWP_NOMOVE Or SWP_NOSIZE
  End If
End Sub


